clear all
close all

xA=0.1
yA=0.1
l2=0.6
l3=0.5
fi20=0
fi30=0

load namerena_data_90_90

% pocet poloh
n_poloh=length(XP)

XP=XP+0.000*rand(n_poloh,1)

% upravime parametry jako vektory
XA=xA*ones(n_poloh,1);
YA=yA*ones(n_poloh,1);
L2=l2*ones(n_poloh,1);
L3=l3*ones(n_poloh,1);
FI20=fi20*ones(n_poloh,1);
FI30=fi30*ones(n_poloh,1);

for j=1:10
    dr1=XA+L2.*cos(FI2+FI20)+L3.*cos(FI2+FI20+FI3+FI30)-XP;
    dr2=YA+L2.*sin(FI2+FI20)+L3.*sin(FI2+FI20+FI3+FI30)-YP;

    dr=-[dr1
         dr2];
   
    [Xprima,Yprima]=prima(FI2+FI20,FI3+FI30,XA,YA,L2,L3); 
     
    figure(1) 
    subplot(2,1,1),plot(dr1),grid on,title('dr1');
    subplot(2,1,2),plot(dr2),grid on,title('dr2');
    
    figure(2)
    scale = 1;
    quiver(XP, YP, scale*(Xprima-XP), scale*(Yprima-YP),0),axis equal
    
    pause

    % vektorovy (pro vsechny polohy) vypocet citlivosti
    df1_dxA=1*ones(n_poloh,1);
    df1_dyA=0*ones(n_poloh,1);
    df1_dl2=cos(FI2+FI20);
    df1_dl3=cos(FI2+FI20+FI3+FI30);
    df1_dfi20=-L2.*sin(FI2+FI20)-L3.*sin(FI2+FI20+FI3+FI30);
    df1_dfi30=-L3.*sin(FI2+FI20+FI3+FI30);
    
    df2_dxA=0*ones(n_poloh,1);
    df2_dyA=1*ones(n_poloh,1);
    df2_dl2=sin(FI2+FI20);
    df2_dl3=sin(FI2+FI20+FI3+FI30);
    df2_dfi20=L2.*cos(FI2+FI20)+L3.*cos(FI2+FI20+FI3+FI30);
    df2_dfi30=L3.*cos(FI2+FI20+FI3+FI30);

    % jacobian
    Jacobi=[df1_dxA, df1_dyA, df1_dl2, df1_dl3, df1_dfi20, df1_dfi30;
            df2_dxA, df2_dyA, df2_dl2, df2_dl3, df2_dfi20, df2_dfi30];
    
    kalibrovatelnost=cond(Jacobi'*Jacobi)

    % reseni pres pseudoinverzni matici
    Difpar=inv(Jacobi'*Jacobi)*Jacobi'*dr;
 
    % zlepseni parametru
	XA=XA+Difpar(1)*ones(n_poloh,1);
	YA=YA+Difpar(2)*ones(n_poloh,1);
	L2=L2+Difpar(3)*ones(n_poloh,1);
	L3=L3+Difpar(4)*ones(n_poloh,1);
	FI20=FI20+Difpar(5)*ones(n_poloh,1);
	FI30=FI30+Difpar(6)*ones(n_poloh,1);	
    
end